unit mainfrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls, ExtCtrls, Grids, ComCtrls, Menus,
  SDL_GeoDB, SDL_replist, SDL_rchart;

type
  TFrmMain = class(TForm)
    Panel1: TPanel;
    ODiag1: TOpenDialog;
    PageControl1: TPageControl;
    TSMap: TTabSheet;
    TSDb: TTabSheet;
    RCMap: TRChart;
    RLDB: TReportListView;
    GDB: TGeoDB;
    SBOpenDb: TSpeedButton;
    SBDbEntry: TSpeedButton;
    PopMenRLDb: TPopupMenu;
    DeleteselectedDBentries1: TMenuItem;
    EditSelectedDBEntry1: TMenuItem;
    PopMenRC: TPopupMenu;
    Zoom111: TMenuItem;
    Pan1: TMenuItem;
    ZoomWindow1: TMenuItem;
    LblSrcstr: TLabel;
    EdSearch: TEdit;
    procedure SBLoadDBClick(Sender: TObject);
    procedure EdSearchChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SBDbEntryClick(Sender: TObject);
    procedure DeleteselectedDBentries1Click(Sender: TObject);
    procedure EditSelectedDBEntry1Click(Sender: TObject);
    procedure ZoomWindow1Click(Sender: TObject);
    procedure Pan1Click(Sender: TObject);
    procedure Zoom111Click(Sender: TObject);
    procedure RCMapZoomPan(Sender: TObject);
  private
    procedure DisplayZoom11;
    procedure LoadGeoData;
    procedure UpdateRLDB;
  public
    { Public declarations }
  end;

var
  FrmMain: TFrmMain;

implementation

{$R *.dfm}

uses
  SDL_sdlbase, SDL_math1, SDL_stringl, edittown;

(******************************************************************************)
procedure TFrmMain.DisplayZoom11;
(******************************************************************************)

begin
RCMap.SetRange (1, 9.3, 46, 17.4, 49.5);
end;


(******************************************************************************)
procedure TFrmMain.LoadGeoData;
(******************************************************************************)

var
  pg     : TgdbPolygon;
  i, k   : integer;
  cnt    : integer;
  long1,
  lat1   : double;
  x1, y1 : integer;

begin
RCMap.ClearGraf;
cnt := 0;
for k:=1 to GDB.NumEntries do
  begin
  case GDB.Data[k].ItemKind of
    gitborder : begin
                if not (((GDB.Data[k].LatLow < RCMap.Scale1Y.RangeLow) and
                         (GDB.Data[k].LatHigh < RCMap.Scale1Y.RangeLow)) or
                        ((GDB.Data[k].LatLow > RCMap.Scale1Y.RangeHigh) and
                         (GDB.Data[k].LatHigh > RCMap.Scale1Y.RangeHigh)) or
                        ((GDB.Data[k].LongLow < RCMap.Scale1X.RangeLow) and
                         (GDB.Data[k].LongHigh < RCMap.Scale1X.RangeLow)) or
                        ((GDB.Data[k].LongLow > RCMap.Scale1X.RangeHigh) and
                         (GDB.Data[k].LongHigh > RCMap.Scale1X.RangeHigh))) then
                  if GDB.RetrievePolygon (k, pg) then
                    begin
                    cnt := cnt + high(pg)+1;
                    RCMap.MoveTo(pg[0].Longit, pg[0].Latit);
                    for i:=low(pg) to high(pg) do
                      RCMap.DrawTo(pg[i].Longit, pg[i].Latit);
                    if GDB.Data[k].Closed then
                      RCMap.DrawTo(pg[0].Longit, pg[0].Latit);
                    end;
                end;
      gitTown : begin
                if not ((GDB.Data[k].LatLow < RCMap.Scale1Y.RangeLow) or
                        (GDB.Data[k].LatLow > RCMap.Scale1Y.RangeHigh) or
                        (GDB.Data[k].LongLow < RCMap.Scale1X.RangeLow) or
                        (GDB.Data[k].LongLow > RCMap.Scale1X.RangeHigh)) then
                  begin
                  RCMap.MarkAt(GDB.Data[k].LongLow, GDB.Data[k].LatLow,8);
                  RCMap.R2M(1, GDB.Data[k].LongLow, GDB.Data[k].LatLow, x1, y1);
                  RCMap.M2R(1, x1, y1-10, Long1, Lat1);
                  RCMap.Text (Long1, Lat1, 8, GDB.Data[k].Name);
                  end;
                end;
      gitBLOB : begin
                if not ((GDB.Data[k].LatHigh < RCMap.Scale1Y.RangeLow) or
                        (GDB.Data[k].LatHigh > RCMap.Scale1Y.RangeHigh) or
                        (GDB.Data[k].LongHigh < RCMap.Scale1X.RangeLow) or
                        (GDB.Data[k].LongHigh > RCMap.Scale1X.RangeHigh)) then
                  begin
                  RCMap.MarkAt(GDB.Data[k].LongHigh, GDB.Data[k].LatHigh,12);
                  RCMap.Text (GDB.Data[k].LongHigh, GDB.Data[k].LatHigh, 8, GDB.Data[k].Name);
                  end;
                end;
  end;
  end;
RCMap.ShowGraf;
end;


(******************************************************************************)
procedure TFrmMain.SBLoadDBClick(Sender: TObject);
(******************************************************************************)

begin
ODiag1.Filter := 'SDL Geo Database|*.sdlgds';
if ODiag1.Execute then
  begin
  GDB.DBname := ODiag1.FileName;
  LoadGeoData;
  DisplayZoom11;
  UpdateRLDB;
  end;
end;


(******************************************************************************)
procedure TFrmMain.UpdateRLDB;
(******************************************************************************)


const
  Headers : array[1..13] of string =
            ('ItemId', 'Name', 'BlobOffset', 'Class', 'Tag', 'ItemKind',
             'Closed', 'CenterLat', 'CenterLong',
             'LatLow', 'LatHigh', 'LongLow', 'LongHigh');

var
  i  : integer;


begin
RLDB.SuppressPaint := true;
for i:=1 to 13 do
  RLDB.Header[i] := Headers[i];
RLDB.NrOfRows := GDB.NumEntries;
for i:=1 to GDB.NumEntries do
  begin
  RLDB[1,i] := Decimal(GDB.Data[i].ItemId,5);
  RLDB[2,i] := GDB.Data[i].Name;
  RLDB[3,i] := hex(GDB.Data[i].BlobOffset,8);
  RLDB[4,i] := IntToStr(GDB.Data[i].ClassFlag);
  RLDB[5,i] := IntToStr(GDB.Data[i].Tag);
  RLDB[6,i] := GDB_ITEMNAMES[GDB.Data[i].ItemKind];
  case GDB.Data[i].ItemKind of
    gitTown : begin
              RLDB[7,i] := '-';
              RLDB[8,i] := strff(GDB.Data[i].LatLow,1,4);
              RLDB[9,i] := strff(GDB.Data[i].LongLow,1,4);
              RLDB[10,i] := '-';
              RLDB[11,i] := '-';
              RLDB[12,i] := '-';
              RLDB[13,i] := '-';
              end;
    gitBorder,
    gitCity,
    gitRiver,
    gitLake : begin
              RLDB[7,i] := BoolToStr(GDB.Data[i].Closed,3);
              RLDB[10,i] := strff(GDB.Data[i].LatLow,1,4);
              RLDB[11,i] := strff(GDB.Data[i].LatHigh,1,4);
              RLDB[12,i] := strff(GDB.Data[i].LongLow,1,4);
              RLDB[13,i] := strff(GDB.Data[i].LongHigh,1,4);
              end;
    gitBLOB : begin
              RLDB[7,i] := '-';
              RLDB[8,i] := '-';
              RLDB[9,i] := strff(GDB.Data[i].LatLow,1,4);
              RLDB[10,i] := strff(GDB.Data[i].LatHigh,1,4);
              RLDB[11,i] := strff(GDB.Data[i].LongLow,1,4);
              RLDB[12,i] := strff(GDB.Data[i].LongHigh,1,4);
              RLDB[13,i] := '-';
              end;
  end;
  end;
RLDB.SuppressPaint := false;
end;


(******************************************************************************)
procedure TFrmMain.EdSearchChange(Sender: TObject);
(******************************************************************************)

var
  NextSearchPos : integer;

begin
PageControl1.ActivePage := TSDb;
RLDB.SuppressPaint := true;
RLDB.DeselectAllRows;
NextSearchPos := -1;
while NextSearchPos <> 0 do
  begin
  NextSearchPos := GDB.SearchData (EdSearch.Text, gitUndefined, NextSearchPos+1, 255);
  if NextSearchPos > 0 then
    RLDB.RowSelected[NextSearchPos] := true;
  end;
RLDB.SuppressPaint := false;
end;


(******************************************************************************)
procedure TFrmMain.FormShow(Sender: TObject);
(******************************************************************************)

begin
LoadGeoData;
DisplayZoom11;
UpdateRLDB;
end;

(******************************************************************************)
procedure TFrmMain.SBDbEntryClick(Sender: TObject);
(******************************************************************************)

var
  Locat : TSCoords;

begin
if FrmEdTown.ShowModal = mrOK then
  begin
  Locat.Latit := FrmEdTown.NIOLat.Value;
  Locat.Longit := FrmEdTown.NIOLong.Value;
  GDB.AddTown(FrmEdTown.EdTownName.Text, Now, 0, Locat, 0, 0, 0);
  LoadGeoData;
  UpdateRLDB;
  end;
end;

(******************************************************************************)
procedure TFrmMain.DeleteselectedDBentries1Click(Sender: TObject);
(******************************************************************************)

var
  IxEntry : longint;

begin
IxEntry := GDB.GetClosestItemIDIx (round(RLDb.AsNumber[1,RLDb.Selection.Top]));
GDB.DeleteData(GDB.IxItemID[IxEntry].index);
LoadGeoData;
UpdateRLDB;
end;

(******************************************************************************)
procedure TFrmMain.EditSelectedDBEntry1Click(Sender: TObject);
(******************************************************************************)

var
  Locat   : TSCoords;
  IxEntry : longint;
  DbEntry : longint;

begin
IxEntry := GDB.GetClosestItemIDIx (round(RLDb.AsNumber[1,RLDb.Selection.Top]));
DbEntry := GDB.IxItemID[IxEntry].index;
if GDB.Data[DbEntry].ItemKind <> gitTown
  then begin
       MessageDlg ('Sorry, cannot edit other data than towns', mtError, [mbOK], 0);
       end
  else begin
       FrmEdTown.NIOLat.Value := GDB.Data[DbEntry].LatLow;
       FrmEdTown.NIOLong.Value := GDB.Data[DbEntry].LongLow;
       FrmEdTown.EdTownName.Text := GDB.Data[DbEntry].Name;
       if FrmEdTown.ShowModal = mrOK then
         begin
         Locat.Latit := FrmEdTown.NIOLat.Value;
         Locat.Longit := FrmEdTown.NIOLong.Value;
         GDB.DeleteData(DbEntry);
         GDB.AddTown(FrmEdTown.EdTownName.Text, Now, 0, Locat, 0, 0, 0);
         LoadGeoData;
         UpdateRLDB;
         end;
       end;
end;


(******************************************************************************)
procedure TFrmMain.ZoomWindow1Click(Sender: TObject);
(******************************************************************************)

begin
RCMap.MouseAction := maZoomWindPos;
end;

(******************************************************************************)
procedure TFrmMain.Pan1Click(Sender: TObject);
(******************************************************************************)

begin
RCMap.MouseAction := maPan;
end;

(******************************************************************************)
procedure TFrmMain.Zoom111Click(Sender: TObject);
(******************************************************************************)

begin
DisplayZoom11;
end;

(******************************************************************************)
procedure TFrmMain.RCMapZoomPan(Sender: TObject);
(******************************************************************************)

begin
LoadGeoData;   
end;

end.
